#include <inttypes.h>

typedef unsigned char byte;    //!< byte type definition

#define max(a, b) (((a) > (b)) ? (a) : (b))
#define min(a, b) (((a) < (b)) ? (a) : (b))

typedef int64_t int64;

#define imgpel unsigned short
#define pel_t imgpel


#define IMG_PAD_SIZE    4   //!< Number of pixels padded around the reference frame (>=4)
#define MAX_LIST_SIZE 33
#define imgpel unsigned short

int    **img4Y_tmp;          //!< for quarter pel interpolation

typedef struct storable_picture
{
  int         size_x, size_y;
  imgpel **   imgY;          //!< Y picture component
} StorablePicture;


const int ONE_FOURTH_TAP[3][2] =
{
  {20,20},
  {-5,-4},
  { 1, 0},
};

void UnifiedOneForthPix (StorablePicture *s)
{
  int i, j, jj,is;
  imgpel  **imgY = s->imgY;
  
  for (i = -IMG_PAD_SIZE; i < s->size_x + IMG_PAD_SIZE; i++)
  {
      is =
        (ONE_FOURTH_TAP[0][0] *
        (imgY[jj][max (0, min (s->size_x - 1, i))] +
         imgY[jj][max (0, min (s->size_x - 1, i + 1))]) +
        ONE_FOURTH_TAP[1][0] *
        (imgY[jj][max (0, min (s->size_x - 1, i - 1))] +
         imgY[jj][max (0, min (s->size_x - 1, i + 2))]) +
        ONE_FOURTH_TAP[2][0] *
        (imgY[jj][max (0, min (s->size_x - 1, i - 2))] +
         imgY[jj][max (0, min (s->size_x - 1, i + 3))]));
      img4Y_tmp[j + IMG_PAD_SIZE][(i + IMG_PAD_SIZE) * 2 + 1] = is * 32;  // 1/2 pix pos
  }
    
}

